' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************
Option Explicit On

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/02/02 
'
' FV-GP440 8ch Sample Program
' -----------------------------------------------------------------
Public Class Form_FVGP440_8CHSAMPLE

    Private m_image As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)              '摜i[̈
    Private m_video As List(Of FVIL.Video.CFviVideoGP440) = New List(Of FVIL.Video.CFviVideoGP440)  'FV-GP440NX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter                              'Ԍvpϐ

    Private m_strIniFilePath As String                                                              'init@CitpXj

    Private m_flgVideoOpened(7) As Boolean                                                          'rfIfoCX̃I[v
    Private m_flgFreerun As Boolean                                                                 't[̏
    Private intErr(7) As Integer                                                                    'G[ԍi[ϐ

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        m_image.Clear()
        m_video.Clear()
        'ԕϐ̏
        For Num As Integer = 0 To 7
            m_flgVideoOpened(Num) = False
            m_image.Add(New FVIL.Data.CFviImage())
            m_video.Add(New FVIL.Video.CFviVideoGP440)
        Next
        m_flgFreerun = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'Ql@\R{{bNX
        ComboBoxBinarizeMode.Items.Clear()
        ComboBoxBinarizeMode.Items.Add("OC")
        ComboBoxBinarizeMode.Items.Add("l")
        ComboBoxBinarizeMode.SelectedIndex = 0

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`Ώۂ̉摜IuWFNgZbg
        CFviImageViewBoard0CH0.Image = m_image(0)
        CFviImageViewBoard0CH1.Image = m_image(1)
        CFviImageViewBoard0CH2.Image = m_image(2)
        CFviImageViewBoard0CH3.Image = m_image(3)
        CFviImageViewBoard1CH0.Image = m_image(4)
        CFviImageViewBoard1CH1.Image = m_image(5)
        CFviImageViewBoard1CH2.Image = m_image(6)
        CFviImageViewBoard1CH3.Image = m_image(7)

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        For Num As Integer = 0 To 7
            If (m_video(Num).IsOpen = True) Then
                m_video(Num).Close()
                m_flgVideoOpened(Num) = False
            End If
        Next

    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()
        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ
        Dim Num As Integer

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        Else
            Me.Close()  'init@CȈꍇ̓TvvO̓I
            Exit Sub
        End If

        Try
            'rfIfoCXI[vĂꍇ̓N[Y
            For Num = 0 To 7
                If (m_video(Num).IsOpen = True) Then
                    m_video(Num).Close()
                    m_flgVideoOpened(Num) = False
                End If
            Next

            'p[^ݒ`lR{{bNXNA
            ComboBoxSettingCH.Items.Clear()
            'foCXI[v
            Dim open_ch As Integer
            'Pڂ̃{[h
            For Num = 0 To 3
                open_ch = 1 << Num
                If (Form_BROWSEINI.SelectChannelNo And open_ch) Then
                    'foCXI[v
                    m_video(Num).Open(Form_BROWSEINI.BoardID0, Num)
                    m_flgVideoOpened(Num) = True
                    '捞摜𐳋K
                    m_video(Num).ChangeImageSize(m_image(Num))
                    'p[^ݒ`lR{{bNXǉ
                    ComboBoxSettingCH.Items.Add("BoardID:" + Form_BROWSEINI.BoardID0.ToString + ",CH" + Num.ToString)
                End If
            Next
            'Qڂ̃{[h
            For Num = 4 To 7
                open_ch = 1 << Num
                If (Form_BROWSEINI.SelectChannelNo And open_ch) Then
                    'foCXI[v
                    m_video(Num).Open(Form_BROWSEINI.BoardID1, Num - 4)
                    m_flgVideoOpened(Num) = True
                    '捞摜𐳋K
                    m_video(Num).ChangeImageSize(m_image(Num))
                    'p[^ݒ`lR{{bNXǉ
                    Dim temp As Integer = Num - 4
                    ComboBoxSettingCH.Items.Add("BoardID:" + Form_BROWSEINI.BoardID1.ToString + ",CH" + temp.ToString)
                End If
            Next
            'p[^ݒ`lR{{bNX
            ComboBoxSettingCH.SelectedIndex = 0

            'init@CR|[lgɐݒ
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    m_video(Num).LoadIniFile(m_strIniFilePath)
                End If
            Next

            'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
            'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
            '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
            'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
            Threading.Thread.Sleep(350)

            'Xe[^X̍XV
            'ŏɃI[vXe[^X\
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    'JIԂ̎擾
                    NumericUpDownExposure.Value = m_video(Num).ExposureTime
                    'rfI̓ItZbg̎擾
                    NumericUpDownOffset.Value = m_video(Num).VideoOffset
                    'Ql臒l̎擾
                    NumericUpDownThreshold.Value = m_video(Num).Binarize.Threshold
                    Exit For
                End If
            Next

            'gKLp[^\
            Dim simtrigger As FVIL.Video.CFviSimTrigger = New FVIL.Video.CFviSimTrigger
            '{[hԃgKLݒp[^\
            Dim trgsharingmode As FVIL.Video.CFviTrgSharingMode = New FVIL.Video.CFviTrgSharingMode
            '2lp[^\
            Dim binarize As FVIL.Video.CFviVideoBinarize = New FVIL.Video.CFviVideoBinarize
            Dim LastCH As Integer

            simtrigger.SwMode = 1               '\tgEFAgKL
            simtrigger.ExtMode = 1              'OgKL

            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    'gK[h̐ݒ
                    m_video(Num).Trigger = 2    'OgKɂ
                    '荞݂sׁAgKL[hɐݒ
                    m_video(Num).SimTrigger = simtrigger
                    'Ql[h̐ݒ
                    binarize = m_video(Num).Binarize
                    binarize.Mode = ComboBoxBinarizeMode.SelectedIndex
                    m_video(Num).Binarize = binarize
                    '捞摜𐳋K
                    m_video(Num).ChangeImageSize(m_image(Num))
                    LastCH = Num
                End If
            Next
            'gKIĂꍇAŌ̃`l̂ݓgKɂB
            If (ComboBoxTrigger.SelectedIndex = 0) Then
                m_video(LastCH).Trigger = 1         'gKɂ
            End If

            '{[hԃgKAݒ́A{[hPʂŐݒ肷邽߁Ae{[hɑ΂1񂸂ݒ܂B
            'Pڂ̃{[h
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    trgsharingmode = m_video(Num).TrgSharingMode
                    trgsharingmode.Mode = 1     'X[u[hɂ
                    m_video(Num).TrgSharingMode = trgsharingmode
                    Exit For
                End If
            Next
            'Qڂ̃{[h
            For Num = 4 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    trgsharingmode = m_video(Num).TrgSharingMode
                    trgsharingmode.Mode = 2         '}X^[[hɂ
                    trgsharingmode.Ch = LastCH - 4  'Ō̃`l̃gKMɍ킹āÃ{[ho͂ɂ
                    m_video(Num).TrgSharingMode = trgsharingmode
                    Exit For
                End If
            Next

            'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
            '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
            'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
            Threading.Thread.Sleep(350)
        Catch ex As Exception
            'G[
            For Num = 0 To 7
                intErr(Num) = m_video(Num).ErrorCode
            Next
            MessageBox.Show("Board0:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString + vbCr + "Board1:CH0=" + intErr(4).ToString + ",CH1=" + intErr(5).ToString + ",CH2=" + intErr(6).ToString + ",CH3=" + intErr(7).ToString, "ErrorCode", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Dim msec As Double
        Dim Num As Integer

        Try
            'ԑJn
            m_timer.Start()
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    'J荞
                    m_video(Num).GrabImageASync(m_image(Num))
                End If
            Next
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    '荞݂܂őҋ@
                    m_video(Num).GrabWait()
                End If
            Next
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")

            'ĕ`
            CFviImageViewBoard0CH0.Refresh()
            CFviImageViewBoard0CH1.Refresh()
            CFviImageViewBoard0CH2.Refresh()
            CFviImageViewBoard0CH3.Refresh()
            CFviImageViewBoard1CH0.Refresh()
            CFviImageViewBoard1CH1.Refresh()
            CFviImageViewBoard1CH2.Refresh()
            CFviImageViewBoard1CH3.Refresh()
        Catch ex As Exception
            'G[
            For Num = 0 To 7
                intErr(Num) = m_video(Num).ErrorCode
                '摜荞ݒ~
                If (m_flgVideoOpened(Num) = True) Then
                    m_video(Num).AbortCapture()
                End If
            Next
            MessageBox.Show("Board0:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString + vbCr + "Board1:CH0=" + intErr(4).ToString + ",CH1=" + intErr(5).ToString + ",CH2=" + intErr(6).ToString + ",CH3=" + intErr(7).ToString, "ErrorCode", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' t[JnE~B
    ''' </remarks>
    Private Sub ButtonGrabContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabContinue.Click

        '{^\ύX
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"       '{^̃eLXg"Grab Continue"ɕύX
            ButtonGrabOne.Enabled = True                    'Grab One{^Lɂ
            m_flgFreerun = False
            Timer1.Enabled = False
        Else
            ButtonGrabContinue.Text = "Stop"                '{^̃eLXg"Stop"ɕύX
            ButtonGrabOne.Enabled = False                   'Grab One{^𖳌ɂ
            m_flgFreerun = True
            Timer1.Interval = 50
            Timer1.Start()
        End If
        Application.DoEvents()

    End Sub

    ''' <summary>
    ''' t[
    ''' </summary>
    ''' <remarks>
    ''' AJ荞݁B
    ''' </remarks>
    Private Sub Timer1Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim msec As Double
        Dim Num As Integer

        Timer1.Stop()

        Try
            'ԑJn
            m_timer.Start()
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    'J荞
                    m_video(Num).GrabImageASync(m_image(Num))
                End If
            Next
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    '荞݂܂őҋ@
                    m_video(Num).GrabWait()
                End If
            Next
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")
            'ĕ`
            CFviImageViewBoard0CH0.Refresh()
            CFviImageViewBoard0CH1.Refresh()
            CFviImageViewBoard0CH2.Refresh()
            CFviImageViewBoard0CH3.Refresh()
            CFviImageViewBoard1CH0.Refresh()
            CFviImageViewBoard1CH1.Refresh()
            CFviImageViewBoard1CH2.Refresh()
            CFviImageViewBoard1CH3.Refresh()

            Timer1.Enabled = True
        Catch ex As Exception
            'G[
            ButtonGrabContinue.Text = "Grab Continue"       '{^̃eLXg"Grab Continue"ɕύX
            ButtonGrabOne.Enabled = True                    'Grab One{^Lɂ
            m_flgFreerun = False
            Timer1.Enabled = False

            For Num = 0 To 7
                intErr(Num) = m_video(Num).ErrorCode
                '摜荞ݒ~
                If (m_flgVideoOpened(Num) = True) Then
                    m_video(Num).AbortCapture()
                End If
            Next
            MessageBox.Show("Board0:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString + vbCr + "Board1:CH0=" + intErr(4).ToString + ",CH1=" + intErr(5).ToString + ",CH2=" + intErr(6).ToString + ",CH3=" + intErr(7).ToString, "ErrorCode", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectionChangeCommitted
        Dim Num As Integer
        Dim LastCH As Integer = 0
        Try
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    m_video(Num).Trigger = 2        'OgKɂ
                    LastCH = Num
                End If
            Next
            'gKIĂꍇAŌ̃`l̂ݓgKɂB
            If (m_flgVideoOpened(LastCH) = True) Then
                If (ComboBoxTrigger.SelectedIndex = 0) Then
                    m_video(LastCH).Trigger = 1         'gKɂ
                End If
            End If
            'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
            '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
            'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
            Threading.Thread.Sleep(350)
        Catch ex As Exception
            'G[
            For Num = 0 To 7
                intErr(Num) = m_video(Num).ErrorCode
            Next
            MessageBox.Show("Board0:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString + vbCr + "Board1:CH0=" + intErr(4).ToString + ",CH1=" + intErr(5).ToString + ",CH2=" + intErr(6).ToString + ",CH3=" + intErr(7).ToString, "ErrorCode", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Binarize ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' OC摜El摜͉̓摜IB
    ''' </remarks>
    Private Sub ComboBoxBinarizeMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxBinarizeMode.SelectedIndexChanged
        Dim Num As Integer
        Try
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    'CFviVideoBinarize\̂̃CX^X̃oʂɕύX鎖͏oȂׁAȉ̗lɂĐݒB
                    Dim bin As FVIL.Video.CFviVideoBinarize = m_video(Num).Binarize
                    bin.Mode = ComboBoxBinarizeMode.SelectedIndex
                    m_video(Num).Binarize = bin
                    '捞摜𐳋K
                    m_video(Num).ChangeImageSize(m_image(Num))
                End If
            Next
        Catch ex As Exception
            'G[
            intErr(0) = m_video(Num).ErrorCode
            MessageBox.Show("ErrorCode : " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Setting CH R{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p[^̎擾B
    ''' </remarks>
    Private Sub ComboBoxSettingCH_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxSettingCH.SelectionChangeCommitted
        Dim Num As Integer = 0
        Dim Cnt As Integer = 0
        Try
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    If (Cnt = ComboBoxSettingCH.SelectedIndex) Then
                        'JIԂ̎擾
                        NumericUpDownExposure.Value = m_video(Num).ExposureTime
                        'rfI̓ItZbg̎擾
                        NumericUpDownOffset.Value = m_video(Num).VideoOffset
                        'Ql臒l̎擾
                        NumericUpDownThreshold.Value = m_video(Num).Binarize.Threshold
                        Exit For
                    End If
                    Cnt = Cnt + 1
                End If
            Next
        Catch ex As Exception
            'G[
            intErr(0) = m_video(Num).ErrorCode
            If (Num < 4) Then
                MessageBox.Show("ErrorCode:Board0:CH" + Num + " = " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Else
                MessageBox.Show("ErrorCode:Board1:CH" + Num + " = " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End Try

    End Sub

    ''' <summary>
    ''' Offset NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfI̓ItZbg̐ݒB
    ''' </remarks>
    Private Sub OffsetValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownOffset.ValueChanged
        Dim Num As Integer
        Dim Cnt As Integer = 0
        Try
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    If (Cnt = ComboBoxSettingCH.SelectedIndex) Then
                        m_video(Num).VideoOffset = NumericUpDownOffset.Value
                        Exit For
                    End If
                    Cnt = Cnt + 1
                End If
            Next
        Catch ex As Exception
            'G[
            intErr(0) = m_video(Num).ErrorCode
            MessageBox.Show("ErrorCode : " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub ExposureValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged
        Dim Num As Integer
        Dim Cnt As Integer = 0
        Try
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    If (Cnt = ComboBoxSettingCH.SelectedIndex) Then
                        m_video(Num).ExposureTime = NumericUpDownExposure.Value
                        Exit For
                    End If
                    Cnt = Cnt + 1
                End If
            Next
        Catch ex As Exception
            'G[
            intErr(0) = m_video(Num).ErrorCode
            MessageBox.Show("ErrorCode : " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Threshold NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2l臒l̐ݒB
    ''' </remarks>
    Private Sub ThresholdValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThreshold.ValueChanged
        Dim Num As Integer
        Dim Cnt As Integer = 0
        Try
            For Num = 0 To 7
                If (m_flgVideoOpened(Num) = True) Then
                    If (Cnt = ComboBoxSettingCH.SelectedIndex) Then
                        'CFviVideoBinarize\̂̃CX^X̃oʂɕύX鎖͏oȂׁAȉ̗lɂĐݒB
                        Dim bin As FVIL.Video.CFviVideoBinarize = m_video(Num).Binarize
                        bin.Threshold = NumericUpDownThreshold.Value
                        m_video(Num).Binarize = bin
                        Exit For
                    End If
                    Cnt = Cnt + 1
                End If
            Next
        Catch ex As Exception
            'G[
            intErr(0) = m_video(Num).ErrorCode
            MessageBox.Show("ErrorCode : " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' ReLoad Ini File{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfIݒpinit@C̍ĐݒB
    ''' </remarks>
    Private Sub ButtonReLoadIni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReLoadIni.Click
        't[Ȃ΁A~B
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"       '{^̃eLXg"Grab Continue"ɕύX
            ButtonGrabOne.Enabled = True                    'Grab One{^Lɂ
            m_flgFreerun = False
            Timer1.Enabled = False
            Application.DoEvents()
        End If

        'init@CI
        fnSetIniFile()

    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                Dim name As String
                Dim temp As Integer
                'gq܂ł̕Zo
                temp = ofdlg.FileName.Length - ofdlg.FileName.LastIndexOfAny(".")
                temp = ofdlg.FileName.Length - temp

                '{[hO`lỎ摜ۑ
                If (m_flgVideoOpened(0) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board0CH0")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard0CH0.Image)
                End If
                '{[hO`lP̉摜ۑ
                If (m_flgVideoOpened(1) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board0CH1")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard0CH1.Image)
                End If
                '{[hO`lQ̉摜ۑ
                If (m_flgVideoOpened(2) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board0CH2")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard0CH2.Image)
                End If
                '{[hO`lR̉摜ۑ
                If (m_flgVideoOpened(3) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board0CH3")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard0CH3.Image)
                End If
                '{[hP`lỎ摜ۑ
                If (m_flgVideoOpened(4) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board1CH0")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard1CH0.Image)
                End If
                '{[hP`lP̉摜ۑ
                If (m_flgVideoOpened(5) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board1CH1")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard1CH1.Image)
                End If
                '{[hP`lQ̉摜ۑ
                If (m_flgVideoOpened(6) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board1CH2")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard1CH2.Image)
                End If
                '{[hP`lR̉摜ۑ
                If (m_flgVideoOpened(7) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_Board1CH3")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewBoard1CH3.Image)
                End If

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)

            Catch ex As FVIL.CFviException
                'G[
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED, _
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If

    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        '\{̐ݒ
        CFviImageViewBoard0CH0.Display.Magnification = 1.0
        CFviImageViewBoard0CH1.Display.Magnification = 1.0
        CFviImageViewBoard0CH2.Display.Magnification = 1.0
        CFviImageViewBoard0CH3.Display.Magnification = 1.0
        CFviImageViewBoard1CH0.Display.Magnification = 1.0
        CFviImageViewBoard1CH1.Display.Magnification = 1.0
        CFviImageViewBoard1CH2.Display.Magnification = 1.0
        CFviImageViewBoard1CH3.Display.Magnification = 1.0
        'ĕ`
        CFviImageViewBoard0CH0.Refresh()
        CFviImageViewBoard0CH1.Refresh()
        CFviImageViewBoard0CH2.Refresh()
        CFviImageViewBoard0CH3.Refresh()
        CFviImageViewBoard1CH0.Refresh()
        CFviImageViewBoard1CH1.Refresh()
        CFviImageViewBoard1CH2.Refresh()
        CFviImageViewBoard1CH3.Refresh()

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        CFviImageViewBoard0CH0.FitImageSize()
        '\{𒲐
        CFviImageViewBoard0CH0.FitImageSize()
        CFviImageViewBoard0CH1.FitImageSize()
        CFviImageViewBoard0CH2.FitImageSize()
        CFviImageViewBoard0CH3.FitImageSize()
        CFviImageViewBoard1CH0.FitImageSize()
        CFviImageViewBoard1CH1.FitImageSize()
        CFviImageViewBoard1CH2.FitImageSize()
        CFviImageViewBoard1CH3.FitImageSize()
        'ĕ`
        CFviImageViewBoard0CH0.Refresh()
        CFviImageViewBoard0CH1.Refresh()
        CFviImageViewBoard0CH2.Refresh()
        CFviImageViewBoard0CH3.Refresh()
        CFviImageViewBoard1CH0.Refresh()
        CFviImageViewBoard1CH1.Refresh()
        CFviImageViewBoard1CH2.Refresh()
        CFviImageViewBoard1CH3.Refresh()

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        Value = CFviImageViewBoard0CH0.Display.Magnification    '{̎擾
        Value = Value + 0.5
        '\{̐ݒ
        CFviImageViewBoard0CH0.Display.Magnification = Value
        CFviImageViewBoard0CH1.Display.Magnification = Value
        CFviImageViewBoard0CH2.Display.Magnification = Value
        CFviImageViewBoard0CH3.Display.Magnification = Value
        CFviImageViewBoard1CH0.Display.Magnification = Value
        CFviImageViewBoard1CH1.Display.Magnification = Value
        CFviImageViewBoard1CH2.Display.Magnification = Value
        CFviImageViewBoard1CH3.Display.Magnification = Value
        'ĕ`
        CFviImageViewBoard0CH0.Refresh()
        CFviImageViewBoard0CH1.Refresh()
        CFviImageViewBoard0CH2.Refresh()
        CFviImageViewBoard0CH3.Refresh()
        CFviImageViewBoard1CH0.Refresh()
        CFviImageViewBoard1CH1.Refresh()
        CFviImageViewBoard1CH2.Refresh()
        CFviImageViewBoard1CH3.Refresh()

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        Value = CFviImageViewBoard0CH0.Display.Magnification    '{̎擾
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageViewBoard0CH0.Display.Magnification = Value
        CFviImageViewBoard0CH1.Display.Magnification = Value
        CFviImageViewBoard0CH2.Display.Magnification = Value
        CFviImageViewBoard0CH3.Display.Magnification = Value
        CFviImageViewBoard1CH0.Display.Magnification = Value
        CFviImageViewBoard1CH1.Display.Magnification = Value
        CFviImageViewBoard1CH2.Display.Magnification = Value
        CFviImageViewBoard1CH3.Display.Magnification = Value
        'ĕ`
        CFviImageViewBoard0CH0.Refresh()
        CFviImageViewBoard0CH1.Refresh()
        CFviImageViewBoard0CH2.Refresh()
        CFviImageViewBoard0CH3.Refresh()
        CFviImageViewBoard1CH0.Refresh()
        CFviImageViewBoard1CH1.Refresh()
        CFviImageViewBoard1CH2.Refresh()
        CFviImageViewBoard1CH3.Refresh()

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageViewBoard0CH0.Display.OverlayAscope.Enable = True
            CFviImageViewBoard0CH0.Display.OverlayAscope.Active = True
            CFviImageViewBoard0CH1.Display.OverlayAscope.Enable = True
            CFviImageViewBoard0CH1.Display.OverlayAscope.Active = True
            CFviImageViewBoard0CH2.Display.OverlayAscope.Enable = True
            CFviImageViewBoard0CH2.Display.OverlayAscope.Active = True
            CFviImageViewBoard0CH3.Display.OverlayAscope.Enable = True
            CFviImageViewBoard0CH3.Display.OverlayAscope.Active = True
            CFviImageViewBoard1CH0.Display.OverlayAscope.Enable = True
            CFviImageViewBoard1CH0.Display.OverlayAscope.Active = True
            CFviImageViewBoard1CH1.Display.OverlayAscope.Enable = True
            CFviImageViewBoard1CH1.Display.OverlayAscope.Active = True
            CFviImageViewBoard1CH2.Display.OverlayAscope.Enable = True
            CFviImageViewBoard1CH2.Display.OverlayAscope.Active = True
            CFviImageViewBoard1CH3.Display.OverlayAscope.Enable = True
            CFviImageViewBoard1CH3.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageViewBoard0CH0.Display.OverlayAscope.Enable = False
            CFviImageViewBoard0CH0.Display.OverlayAscope.Active = False
            CFviImageViewBoard0CH1.Display.OverlayAscope.Enable = False
            CFviImageViewBoard0CH1.Display.OverlayAscope.Active = False
            CFviImageViewBoard0CH2.Display.OverlayAscope.Enable = False
            CFviImageViewBoard0CH2.Display.OverlayAscope.Active = False
            CFviImageViewBoard0CH3.Display.OverlayAscope.Enable = False
            CFviImageViewBoard0CH3.Display.OverlayAscope.Active = False
            CFviImageViewBoard1CH0.Display.OverlayAscope.Enable = False
            CFviImageViewBoard1CH0.Display.OverlayAscope.Active = False
            CFviImageViewBoard1CH1.Display.OverlayAscope.Enable = False
            CFviImageViewBoard1CH1.Display.OverlayAscope.Active = False
            CFviImageViewBoard1CH2.Display.OverlayAscope.Enable = False
            CFviImageViewBoard1CH2.Display.OverlayAscope.Active = False
            CFviImageViewBoard1CH3.Display.OverlayAscope.Enable = False
            CFviImageViewBoard1CH3.Display.OverlayAscope.Active = False
        End If
        'ĕ`
        CFviImageViewBoard0CH0.Refresh()
        CFviImageViewBoard0CH1.Refresh()
        CFviImageViewBoard0CH2.Refresh()
        CFviImageViewBoard0CH3.Refresh()
        CFviImageViewBoard1CH0.Refresh()
        CFviImageViewBoard1CH1.Refresh()
        CFviImageViewBoard1CH2.Refresh()
        CFviImageViewBoard1CH3.Refresh()

    End Sub

End Class
